DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Types | Public Member Functions | Private Member Functions | Private Attributes | List of all members
DcmEncapsulatedDocument Class Reference

This class handles common functions for the conversion of documents into encapsulated DICOM SOP instances. More...

## Public Types
enum | DocumentType { DT_pdfDocument , DT_cdaDocument , DT_stlDocument , DT_mtlDocument , DT_objDocument , DT_unknownDocument }
| document type of encapsulated document More...

## Public Member Functions
| DcmEncapsulatedDocument ()
| Constructor.
| ~DcmEncapsulatedDocument ()
| Destructor.
void | addCommandlineOptions (OFCommandLine &cmd) const
| Add CDA specific command line options to the OFCommandLine object passed to the constructor. More...
void | parseArguments (OFConsoleApplication &app, OFCommandLine &cmd)
| Parse and evaluate the given command line arguments. More...
OFCondition | insertEncapsulatedDocument ()
| Identify document format and insert encapsulated document data into the dataset. More...
OFCondition | createIdentifiers ()
| Get study or series data from series file. More...
OFCondition | formatSpecificProcessing ()
| Perform format specific processing such as extracting information from the document content. More...
OFCondition | createHeader ()
| Write header fields to the DICOM dataset. More...
OFCondition | applyOverrideKeys ()
| Copy override keys over existing keys in given dataset. More...
OFString | getInputFileName ()
| Returns the input file name. More...
OFString | getOutputFileName ()
| Returns the output file name. More...
OFCondition | saveFile ()
| Save the output file. More...

## Private Member Functions
OFCondition | getCDAData ()
| Retrieve patient, concept and document data from a CDA file and check for conflicts with series, study and user input. More...
OFCondition | addFrameOfReferenceModule (DcmItem *dataset)
| Add mandatory Frame of Reference Module attributes to dataset. More...
OFCondition | addEnhancedGeneralEquipmentModule (DcmItem *dataset)
| Add mandatory Enhanced General Equipment Module attributes to dataset. More...
OFCondition | addManufacturing3DModelModule (DcmItem *dataset)
| Add mandatory Manufacturing 3D Model Module attributes to dataset. More...

## Private Attributes
OFString | ifname_
| input file name
OFString | ofname_
| output file name
OFString | patientBirthdate_
| patient's birth date
OFString | patientID_
| patient ID
OFString | patientName_
| patient name
OFString | patientSex_
| patient's sex
OFString | conceptCM_
| document title: code meaning
OFString | conceptCSD_
| document title: code scheme designator
OFString | conceptCV_
| document title: code value
OFString | documentTitle_
| document title
OFString | seriesFile_
| file to read series data from
OFString | seriesUID_
| series instance UID
OFString | studyUID_
| study instance UID
OFString | specificCharSet_
| specific character set (from series file)
OFString | modality_
| modality (from series file)
E_EncodingType | oenctype_
| DICOM sequence encoding: explicit or undefined length.
E_FileWriteMode | writeMode_
| write mode for the DICOM file
E_GrpLenEncoding | oglenc_
| handling of group length encoding
E_PaddingEncoding | opadenc_
| handling of data set trailing padding
E_TransferSyntax | oxfer_
| transfer syntax for the DICOM file
OFCmdUnsignedInt | filepad_
| padding for the main dataset
OFCmdUnsignedInt | itempad_
| padding for sequence items
OFBool | readSeriesInfo_
| true if we are supposed to read series information from another DICOM file
OFBool | annotation_
| burned-in annotation present?
OFBool | increment_
| increment instance number from given DICOM series file?
OFCmdSignedInt | instance_
| instance number
OFList< OFString > | overrideKeys_
| list of DICOM attributes and attribute values to be applied after conversion
OFString | cda_mediaTypes
| CDA media types.
OFString | hl7_InstanceIdentifier
| CDA instance identifier.
OFBool | override_
| should CDA header values override DICOM values?
OFString | frameOfReferenceUID_
| frame of reference UID
OFString | positionReferenceIndicator_
| position reference indicator
OFString | manufacturer_
| manufacturer
OFString | manufacturerModelName_
| manufacturer's model name
OFString | deviceSerialNumber_
| device serial number
OFString | softwareVersions_
| software version(s) (VM 1-n)
OFString | measurementUnitsCM_
| 3D model measurement units code meaning
OFString | measurementUnitsCSD_
| 3D model measurement units code scheme designator
OFString | measurementUnitsCV_
| 3D model measurement units code value
DocumentType | ftype_
| Type of file currently being converted.
DcmFileFormat | dfile_
| DICOM file.

## Detailed Description

This class handles common functions for the conversion of documents into encapsulated DICOM SOP instances.

## Member Enumeration Documentation

## ◆ DocumentType

enum DcmEncapsulatedDocument::DocumentType

document type of encapsulated document

Enumerator
DT_pdfDocument | PDF document.
DT_cdaDocument | CDA document.
DT_stlDocument | STL document.
DT_mtlDocument | MTL document.
DT_objDocument | OBJ document.
DT_unknownDocument | unknown document

## Member Function Documentation

## ◆ addCommandlineOptions()

void DcmEncapsulatedDocument::addCommandlineOptions | ( | OFCommandLine & | cmd | ) | const

Add CDA specific command line options to the OFCommandLine object passed to the constructor.

Parameters

  cmd | a reference to an OFCommandLine object used to parse the command line argument give to the calling application.

Returns
  none.

## ◆ addEnhancedGeneralEquipmentModule()

OFCondition DcmEncapsulatedDocument::addEnhancedGeneralEquipmentModule | ( | DcmItem * | dataset | ) |
| private

Add mandatory Enhanced General Equipment Module attributes to dataset.

Parameters

  dataset | output dataset

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ addFrameOfReferenceModule()

OFCondition DcmEncapsulatedDocument::addFrameOfReferenceModule | ( | DcmItem * | dataset | ) |
| private

Add mandatory Frame of Reference Module attributes to dataset.

Parameters

  dataset | output dataset

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ addManufacturing3DModelModule()

OFCondition DcmEncapsulatedDocument::addManufacturing3DModelModule | ( | DcmItem * | dataset | ) |
| private

Add mandatory Manufacturing 3D Model Module attributes to dataset.

Parameters

  dataset | output dataset

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ applyOverrideKeys()

OFCondition DcmEncapsulatedDocument::applyOverrideKeys | ( |  | ) |

Copy override keys over existing keys in given dataset.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ createHeader()

OFCondition DcmEncapsulatedDocument::createHeader | ( |  | ) |

Write header fields to the DICOM dataset.

Note
  This method should be called after insertEncapsulatedDocument() to make sure that the document format has been identified.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ createIdentifiers()

OFCondition DcmEncapsulatedDocument::createIdentifiers | ( |  | ) |

Get study or series data from series file.

Generate UID if none present.

Note
  This method should be called after insertEncapsulatedDocument() to make sure that the document format has been identified.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ formatSpecificProcessing()

OFCondition DcmEncapsulatedDocument::formatSpecificProcessing | ( |  | ) |

Perform format specific processing such as extracting information from the document content.

Note
  This method should be called after insertEncapsulatedDocument() and after createIdentifiers() to make sure that the document format has been identified and inconsistencies between DICOM and document level can be checked.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ getCDAData()

OFCondition DcmEncapsulatedDocument::getCDAData | ( |  | ) |
| private

Retrieve patient, concept and document data from a CDA file and check for conflicts with series, study and user input.

Also retrieve all mediatypes found in the CDA document.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ getInputFileName()

OFString DcmEncapsulatedDocument::getInputFileName | ( |  | ) |

Returns the input file name.

Returns
  the input file name as OFString.

## ◆ getOutputFileName()

OFString DcmEncapsulatedDocument::getOutputFileName | ( |  | ) |

Returns the output file name.

Returns
  the output file name as OFString.

## ◆ insertEncapsulatedDocument()

OFCondition DcmEncapsulatedDocument::insertEncapsulatedDocument | ( |  | ) |

Identify document format and insert encapsulated document data into the dataset.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ parseArguments()

void DcmEncapsulatedDocument::parseArguments | ( | OFConsoleApplication & | app,
|  | OFCommandLine & | cmd
| ) |  |

Parse and evaluate the given command line arguments.

Parameters

  app | a reference to an OFConsoleApplication object used in the calling application.
  cmd | a reference to an OFCommandLine object used to parse the command line argument give to the calling application.

Returns
  none.

## ◆ saveFile()

OFCondition DcmEncapsulatedDocument::saveFile | ( |  | ) |

Save the output file.

Returns
  EC_Normal if successful, an error code otherwise.

The documentation for this class was generated from the following file:

- dcmdata/include/dcmtk/dcmdata/dcencdoc.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1